## libkarma 0.0.6

=== Makefile ===
LK_SRC=src
TOOLSDIR=tools
PREFIX=/usr/local
VERSION=0.0.6

export PREFIX
export VERSION

DISTNAME=libkarma-$(VERSION)
DISTFILES= $(LK_SRC)/{Jamfile,Makefile,*[ch]} \
	$(TOOLSDIR)/{Jamfile,Makefile,*[ch]} \
	karma-sharp/{Makefile,karma-sharp.pc.in,Song.cs,Device.cs} \
	Jamfile Makefile COPYING ChangeLog THANKS INSTALL TODO \
	install-sh karma-tools.spec

all: libkarma tools karma-sharp

install: libkarma tools karma-sharp
	cd $(LK_SRC) && $(MAKE) install
	cd karma-sharp && $(MAKE) install
	cd tools && $(MAKE) install

uninstall: 
	cd $(LK_SRC) && $(MAKE) uninstall
	cd karma-sharp && $(MAKE) uninstall
	cd tools && $(MAKE) uninstall

libkarma: FORCE
	cd $(LK_SRC) && $(MAKE)

tools: FORCE
	cd $(TOOLSDIR) && $(MAKE)

karma-sharp: FORCE
	cd karma-sharp && $(MAKE)

dist: 
	mkdir -p $(DISTNAME)
	mkdir -p $(DISTNAME)/$(LK_SRC)
	mkdir -p $(DISTNAME)/$(TOOLSDIR)
	mkdir -p $(DISTNAME)/karma-sharp
	for i in $(DISTFILES); do \
		cp $$i $(DISTNAME)/$$i ; \
	done
	tar czvf $(DISTNAME).tar.gz $(DISTNAME)
	$(RM) -r $(DISTNAME)

distcheck: dist
	mkdir build
	cd build && tar xzvf ../$(DISTNAME).tar.gz && \
	cd $(DISTNAME) && $(MAKE)
	$(RM) -r build

.PHONY: clean

clean-libkarma:
	( cd $(LK_SRC)    ; make clean )

clean-tools:
	( cd $(TOOLSDIR)  ; make clean )

clean-karma-sharp:
	( cd karma-sharp  ; make clean )

clean: clean-tools clean-libkarma clean-karma-sharp

FORCE:

=== karma-sharp/Makefile ===
ASSEMBLY_SOURCES=Song.cs Device.cs
ASSEMBLY_RESOURCES=
MCS=$(shell which mcs)
MCS_FLAGS = -debug

ifeq ($(MCS),)
	HAS_MONO=
else
	HAS_MONO=true
endif

ifdef HAS_MONO
	ASSEMBLY=karma-sharp.dll
else
	ASSEMBLY=
	PRINT = Note: mcs not found, not building karma-sharp!
endif

all: $(ASSEMBLY)
	@echo $(PRINT)


karma-sharp.pc: FORCE
	sed -e 's,@prefix@,$(PREFIX),g; s,@VERSION@,$(VERSION),g' \
	karma-sharp.pc.in > karma-sharp.pc

ifdef HAS_MONO
install: $(ASSEMBLY) karma-sharp.pc
	../install-sh -d $(PREFIX)/lib/karma-sharp
	../install-sh -d $(PREFIX)/lib/pkgconfig
	../install-sh -t $(PREFIX)/lib/karma-sharp $(ASSEMBLY)
	../install-sh -t $(PREFIX)/lib/pkgconfig -m 0644 karma-sharp.pc
else
install:

endif

uninstall: FORCE
	$(RM) -r $(PREFIX)/lib/karma-sharp
	$(RM) $(PREFIX)/lib/pkgconfig/karma-sharp.pc

$(ASSEMBLY): $(ASSEMBLY_SOURCES) $(ASSEMBLY_RESOURCES)
	$(MCS) $(MCS_FLAGS) -unsafe -target:library -out:$@ $(ASSEMBLY_SOURCES) $(ASSEMBLY_RESOURCES:%=-resource:%) -r:Mono.Posix

clean: FORCE
	$(RM) *.dll *.mdb karma-sharp.pc

FORCE:

=== src/Makefile ===
NAME=libkarma
VERSION=0.0.6
TARGET=$(NAME)
SRCS= errors.c fdb.c hash.c karma.c karmaLan.c karmaUsb.c md5.c mountSearch.c \
	mp3.c playlist.c properties.c rio_rw.c ssdp.c status.c utf8.c \
	util.c wav.c
INST_HEADERS=lkarma.h utf8.h

LIBDIR=../lib

CC=gcc
AR=ar
RANLIB=ranlib

CFLAGS+=-fPIC -D_REENTRANT -Wall -pedantic
CFLAGS+=-ggdb -W -Wchar-subscripts -Wmissing-prototypes 
CFLAGS+=-Wmissing-declarations -Wno-switch -Wredundant-decls -Wno-unused

default: all

install:
	../install-sh -m 0755 -d $(PREFIX)/lib
	../install-sh -m 0755 -d $(PREFIX)/include
	../install-sh -m 0755 -d $(PREFIX)/include/libkarma
	../install-sh -m 0644 -t $(PREFIX)/lib/ $(LIBDIR)/$(TARGET).a
	../install-sh -m 0755 -t $(PREFIX)/lib/ $(LIBDIR)/$(TARGET).so
	../install-sh -m 0644 -t $(PREFIX)/include/libkarma/ $(INST_HEADERS)

uninstall:
	$(RM) $(PREFIX)/lib/$(TARGET).a $(PREFIX)/lib/$(TARGET).so*
	$(RM) -r $(PREFIX)/include/libkarma

OBJS = $(SRCS:.c=.o)

$(LIBDIR):
	@[ -d $(LIBDIR) ] || mkdir $(LIBDIR) > /dev/null 2>&1

$(TARGET): $(OBJS) $(LIBDIR)
	$(AR) r $(LIBDIR)/$(TARGET).a $(OBJS)
	$(RANLIB) $(LIBDIR)/$(TARGET).a

shared: $(OBJS) $(LIBDIR)
	$(CC) -shared $(OBJS) $(CFLAGS) -o $(LIBDIR)/$(TARGET).so -ltag_c

all: $(TARGET) shared

.PHONY: clean

clean:
	rm -rf $(OBJS) $(LIBDIR)/

=== tools/Makefile ===
INCLUDES=-I../src
LIBDIR=../lib
LIBKARMA=$(LIBDIR)/libkarma.a

SRCS=pathedit.c

CC=gcc
CFLAGS+=-Wall -pedantic
LDFLAGS+=-ltag_c -lz

OBJS=$(SRCS:.c=.o)
TOOLS=riocp chprop playlist_show karma_helper

default: $(TOOLS)
all: $(TOOLS)

riocp: riocp.c $(OBJS) $(LIBKARMA)
	$(CC) $(INCLUDES) $(LDFLAGS) $(CFLAGS) $@.c -o $@ $(OBJS) $(LIBKARMA)

chprop: chprop.c $(LIBKARMA)
	$(CC) $(INCLUDES) $(LDFLAGS) $(CFLAGS) $@.c -o $@ $(LIBKARMA)

playlist_show: playlist_show.c $(LIBKARMA)
	$(CC) $(INCLUDES) $(LDFLAGS) $(CFLAGS) $@.c -o $@ $(LIBKARMA)

karma_helper: karma_helper.c
	$(CC) $(INCLUDES) $(CFLAGS) $@.c -o $@ -lusb

install:
	../install-sh -m 0755 -d $(PREFIX)/bin
	../install-sh -m 0755 -t $(PREFIX)/bin/ $(TOOLS)

uninstall:
	cd $(PREFIX)/bin && $(RM) $(TOOLS)

.PHONY: clean

clean:
	rm -rf *.o $(TOOLS)

## libkarma 0.1.2

=== Makefile ===
--- 
+++ 
@@ -1,7 +1,9 @@
 LK_SRC=src
 TOOLSDIR=tools
-PREFIX=/usr/local
-VERSION=0.0.6
+PREFIX=/usr
+INSTALL?=./install-sh
+VERSION=0.1.2
+SHELL=/bin/bash
 
 export PREFIX
 export VERSION
@@ -10,26 +12,40 @@
 DISTFILES= $(LK_SRC)/{Jamfile,Makefile,*[ch]} \
 	$(TOOLSDIR)/{Jamfile,Makefile,*[ch]} \
 	karma-sharp/{Makefile,karma-sharp.pc.in,Song.cs,Device.cs} \
-	Jamfile Makefile COPYING ChangeLog THANKS INSTALL TODO \
+	Jamfile Makefile COPYING ChangeLog THANKS INSTALL* TODO \
 	install-sh karma-tools.spec
+DOCS=THANKS TODO ChangeLog
+
+INSTALL_DIR     := $(INSTALL) -d -o root -g root -m 0755
+INSTALL_FILE    := $(INSTALL)    -o root -g root -m 0644
+INSTALL_PROGRAM := $(INSTALL)    -o root -g root -m 0755
+INSTALL_SCRIPT  := $(INSTALL)    -o root -g root -m 0755
 
 all: libkarma tools karma-sharp
+
+static: libkarma toolsStatic karma-sharp
 
 install: libkarma tools karma-sharp
 	cd $(LK_SRC) && $(MAKE) install
 	cd karma-sharp && $(MAKE) install
 	cd tools && $(MAKE) install
+	$(INSTALL_DIR) $(DESTDIR)/$(PREFIX)/share/doc/libkarma
+	$(INSTALL_FILE) $(DOCS) $(DESTDIR)/$(PREFIX)/share/doc/libkarma
 
 uninstall: 
 	cd $(LK_SRC) && $(MAKE) uninstall
 	cd karma-sharp && $(MAKE) uninstall
 	cd tools && $(MAKE) uninstall
+	rm -rf $(DESTDIR)/$(PREFIX)/share/doc/libkarma
 
 libkarma: FORCE
 	cd $(LK_SRC) && $(MAKE)
 
 tools: FORCE
 	cd $(TOOLSDIR) && $(MAKE)
+
+toolsStatic: FORCE
+	cd $(TOOLSDIR) && $(MAKE) static
 
 karma-sharp: FORCE
 	cd karma-sharp && $(MAKE)
@@ -39,9 +55,7 @@
 	mkdir -p $(DISTNAME)/$(LK_SRC)
 	mkdir -p $(DISTNAME)/$(TOOLSDIR)
 	mkdir -p $(DISTNAME)/karma-sharp
-	for i in $(DISTFILES); do \
-		cp $$i $(DISTNAME)/$$i ; \
-	done
+	cp --parents $(DISTFILES) $(DISTNAME)
 	tar czvf $(DISTNAME).tar.gz $(DISTNAME)
 	$(RM) -r $(DISTNAME)

=== karma-sharp/Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 ASSEMBLY_SOURCES=Song.cs Device.cs
 ASSEMBLY_RESOURCES=
-MCS=$(shell which mcs)
+MCS=$(shell which gmcs)
 MCS_FLAGS = -debug
 
 ifeq ($(MCS),)
@@ -25,11 +25,11 @@
 	karma-sharp.pc.in > karma-sharp.pc
 
 ifdef HAS_MONO
-install: $(ASSEMBLY) karma-sharp.pc
-	../install-sh -d $(PREFIX)/lib/karma-sharp
-	../install-sh -d $(PREFIX)/lib/pkgconfig
-	../install-sh -t $(PREFIX)/lib/karma-sharp $(ASSEMBLY)
-	../install-sh -t $(PREFIX)/lib/pkgconfig -m 0644 karma-sharp.pc
+install: $(ASSEMBLY) karma-sharp.pc $(ASSEMBLY).config
+	../install-sh -d $(DESTDIR)$(PREFIX)/lib/karma-sharp
+	../install-sh -d $(DESTDIR)$(PREFIX)/lib/pkgconfig
+	../install-sh -t $(DESTDIR)$(PREFIX)/lib/karma-sharp $(ASSEMBLY) $(ASSEMBLY).config
+	../install-sh -t $(DESTDIR)$(PREFIX)/lib/pkgconfig -m 0644 karma-sharp.pc
 else
 install:

=== debian/changelog ===
libkarma (0.1.2-8) unstable; urgency=medium

  * QA upload.

  [ Debian Janitor ]
  * Update standards version to 4.6.1, no changes needed.
  * Avoid explicitly specifying -Wl,--as-needed linker flag.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Sun, 27 Nov 2022 21:23:44 +0000

libkarma (0.1.2-7) unstable; urgency=medium

  * QA upload.

  [ Debian Janitor ]
  * Remove constraints unnecessary since buster:
    + Build-Depends-Indep: Drop versioned constraint on cli-common-dev and
      mono-devel.
    + libkarma-cil-dev: Drop versioned constraint on libkarma-cil in Replaces.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Fri, 27 May 2022 20:10:17 +0100

libkarma (0.1.2-6) unstable; urgency=medium

  * QA upload.
  * Fix broken expansion of makefile variables that I introduced
    in the previous upload.

 -- Niels Thykier <niels@thykier.net>  Fri, 17 Apr 2020 20:31:32 +0000

libkarma (0.1.2-5) unstable; urgency=medium

  * QA upload.

  [ Debian Janitor ]
  * Update standards version, no changes needed.
  * Bump debhelper from old 11 to 12.
  * Update standards version to 4.4.1, no changes needed.

  [ Niels Thykier ]
  * Bump Standards-Version to 4.5.0 - no changes needed.
  * Set Rules-Requires-Root to no after passing relevant flags
    to upstream make file to avoid using root while installing
    the package.
  * Bump debhelper-compat to 13.
  * Add exclude to dh_clean to avoid removing files included in
    the upstream tarball.

  [ Helmut Grohne ]
  * Fix FTCBFS: Split out Build-Depends-Indep again. (Closes: #918477)

 -- Niels Thykier <niels@thykier.net>  Fri, 17 Apr 2020 20:18:40 +0000

libkarma (0.1.2-4) unstable; urgency=medium

  * QA upload.
  * debian/control:
    + Merge Build-Dep-Indep and Build-Dep to simplify dependency
      relationship and fix FTBFS on Debian Buildd.
  * debian/patches:
    + Apply patch to make package cross buildable. (Closes: #901265)

 -- Boyuan Yang <byang@debian.org>  Tue, 01 Jan 2019 18:36:36 -0500

libkarma (0.1.2-3) unstable; urgency=medium

  * QA upload.
  * Rebuild for Debian Buster.
  * debian/control:
    + Bump Standards-Version to 4.3.0.
    + Bump debhelper compat to v11.
    + Build-depend on debhelper-compat (= 11) instead of using
      debian/compat file.
    + Bump versioned build-dependency on cli-common-dev to
      (>= 0.8~) as indicated in buildlog.
    + Replace obsoleted Priority: extra with Priority: optional.
    + Add Vcs-* fields for packaging repository.
    + Update homepage field with secure uri.
    + Fix the section info for package libkarma-cil-dev (cli-mono).
  * debian/watch: Use secure uri.
  * debian/copyright: Remove trailing empty line.
  * debian/rules:
    + Use "dh_missing --fail-missing".
    + Force non-parallel build to fix FTBFS.

 -- Boyuan Yang <byang@debian.org>  Sun, 30 Dec 2018 20:27:34 +0800

libkarma (0.1.2-2.5) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS when building only arch-indep packages. Implement the
    workaround documented in #830416: when dh_makeshlibs has not been
    called, create a phony shlibs.local so that dh_clideps does not crash.
    (Closes: #806629)

 -- Sébastien Villemot <sebastien@debian.org>  Fri, 16 Dec 2016 22:36:06 +0100

libkarma (0.1.2-2.4) unstable; urgency=medium

  * Non-maintainer upload.
  * Rebuild for CLR 4.5 transition (Closes: #805464)

 -- Jo Shields <directhex@apebox.org>  Wed, 18 Nov 2015 12:22:18 +0000

libkarma (0.1.2-2.3) unstable; urgency=low

  * Non-maintainer upload
  * Rebuild for CLR 4.0 transition (Closes: #656379)
  * Drop deprecated cli.make include

 -- Chow Loong Jin <hyperair@debian.org>  Thu, 19 Jan 2012 04:59:04 +0800

libkarma (0.1.2-2.2) unstable; urgency=low

  * Non-maintainer upload.
  * Fix installing of karma-sharp dll when gmcs is not present (Closes: #634203)

 -- Chow Loong Jin <hyperair@ubuntu.com>  Mon, 18 Jul 2011 01:13:21 +0800

libkarma (0.1.2-2.1) unstable; urgency=low

  * Non-maintainer upload.
  * Fix build on non-mono architectures (Closes: #632770)
  * Use Debian's default C# compiler (mono-csc)
    Thanks to Julian Taylor <jtaylor.debian@googlemail.com> (Closes: #627299)

 -- Chow Loong Jin <hyperair@ubuntu.com>  Wed, 06 Jul 2011 04:55:06 +0800

libkarma (0.1.2-2) unstable; urgency=low

  * upload to unstable

 -- Joe Nahmias <jello@debian.org>  Sat, 23 Apr 2011 22:04:02 -0400

libkarma (0.1.2-1) experimental; urgency=low

  * New upstream release
    + 05_add_karma-sharp_dllmap: removed, applied upstream
    + 15_install_docs: removed, applied upstream
    + 25_update_manpages: removed, applied upstream
    + 50_add_write_smalldb_debug_info: removed, applied upstream
    + 80_gmcs: removed, applied upstream
    + 90_fix_debbug_567693: removed, applied upstream
  * debian/control: bump std-ver to 3.9.2, no changes required

 -- Joe Nahmias <jello@debian.org>  Fri, 22 Apr 2011 13:55:57 -0400

libkarma (0.1.1-3) experimental; urgency=low

  * control: move cli-common-dev from B-D-I to B-D, really closes:
    #614772.

 -- Joe Nahmias <jello@debian.org>  Tue, 15 Mar 2011 21:18:58 -0400

libkarma (0.1.1-2) experimental; urgency=low

  * Don't use --with cli in clean target, closes: #614772
  * improve karma-tools long description, closes: #515109.
  * 20_install_playlist_show_as_example: removed, part went upstream,
    rest went into debian/libkarma-dev.examples; closes: #547304.

 -- Joe Nahmias <jello@debian.org>  Thu, 24 Feb 2011 00:15:49 -0500

libkarma (0.1.1-1) experimental; urgency=low

  * New upstream release, closes: #427401.
    + 05_add_karma-sharp_dllmap: refresh
    + 51_fix_dmap_and_playlist_counts: included upstream
    + 52_check_for_upload_errors: included upstream
    + 60_fix_prop_count_off_by_ones: included upstream
    + 70_fix_prop-write-smalldb_retval: included upstream
    + 90_fix_debbug_567693: refresh
  * debian/watch: update upstream location
  * debian/control: bump std-ver to 3.9.1 -- no changes
  * drop dpatch and convert to source format 3.0 (quilt)


=== debian/control ===
Source: libkarma
Priority: optional
Maintainer: Debian QA Group <packages@qa.debian.org>
Build-Depends:
 debhelper-compat (= 13),
 libtagc0-dev,
 libusb-dev,
 zlib1g-dev,
Build-Depends-Indep:
 dh-sequence-cli,
 cli-common-dev,
 mono-devel,
Rules-Requires-Root: no
Standards-Version: 4.6.1
Section: libs
Homepage: https://www.freakysoft.de/libkarma/
Vcs-Git: https://salsa.debian.org/debian/libkarma.git
Vcs-Browser: https://salsa.debian.org/debian/libkarma

Package: karma-tools
Section: utils
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Rio Karma access library [tools]
 Some basic utilities for use with the Rio Karma music player.
 Includes:
 .
   * chprop - changes file properties on the Rio Karma
   * karma_helper - adjusts the state of the Rio Karma
   * riocp - transfers files to and from the Rio Karma

Package: libkarma-cil
Section: cli-mono
Architecture: all
Depends:
 ${cli:Depends},
 ${misc:Depends},
Description: Rio Karma access library [CLI runtime library]
 Also known as karma-sharp, this is a CLI library (.dll) that
 provides (read/write) access to the Rio Karma music player using
 either the usb (with OMFS) or network (PEARL) interface.
 .
 This package contains the runtime glue library needed by C# programs
 using the facilities provided by libkarma.

Package: libkarma-cil-dev
Section: cli-mono
Architecture: all
Depends:
 libkarma-cil (= ${binary:Version}),
 ${misc:Depends},
Description: Rio Karma access library [CLI library development files]
 Also known as karma-sharp, this is a CLI library (.dll) that
 provides (read/write) access to the Rio Karma music player using
 either the usb (with OMFS) or network (PEARL) interface.
 .
 This package contains development files for the karma-sharp library used for
 compilation.

Package: libkarma-dev
Section: libdevel
Architecture: any
Depends:
 libkarma0 (= ${binary:Version}),
 libtagc0-dev,
 ${misc:Depends},
Description: Rio Karma access library [development files]
 libkarma is a C language library that provides (read/write) access
 to the Rio Karma music player using either the usb (with OMFS) or
 network (PEARL) interface.
 .
 libkarma allows developers to do the following:
 .
   * login
   * read, write and delete music or data files
   * read and write file information
   * write music or taxi files with one function, including setting
     all metadata
 .
 This package contains the development files needed to compile
 programs using the facilities provided by libkarma.

Package: libkarma0
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Rio Karma access library [runtime files]
 libkarma is a C language library that provides (read/write) access
 to the Rio Karma music player using either the usb (with OMFS) or
 network (PEARL) interface.
 .
 This package contains the runtime library needed by programs using
 the facilities provided by libkarma.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

override_dh_auto_build:
	dh_auto_build -- MCS=$(shell which mono-csc)

override_dh_auto_install:
	dh_auto_install -- MCS=$(shell which mono-csc) \
            INSTALL_DIR='$$(INSTALL) -d -m 0755' \
            INSTALL_FILE='$$(INSTALL) -m 0644' \
            INSTALL_PROGRAM='$$(INSTALL) -m 0755' \
            INSTALL_SCRIPT='$$(INSTALL) -m 0755' \

%:
	dh $@ --no-parallel

# dh_clideps expects to see dh_makeshlibs called before it, but dh_makeshlibs
# is never called when building only arch-indep packages. So we force the issue
# by making a phony shlibs.local file that dh_clideps will accept, if no others
# exist. See #806629 for the specific case of libkarma and #830416 for the bug
# in dh_clideps.
override_dh_clideps:
	if ! grep -q . debian/*/DEBIAN/shlibs; then echo libkarma 0 libkarma0 > debian/shlibs.local; fi
	dh_clideps
	rm -f debian/shlibs.local

# Upstream incldued some Makefile.orig in the tarball; exclude those to
# avoid fighting with git.
override_dh_clean:
	dh_clean -X Makefile.orig

override_dh_missing:
	dh_missing --fail-missing

=== debian/watch ===
version=3

https://www.freakysoft.de/libkarma/ libkarma-(.*)\.tar\.gz debian uupdate
